package com.jiuqi.util.patterns;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.util.StringUtils;
import com.jiuqi.util.patterns.IPattern;
import com.jiuqi.util.patterns.ITranslator;
import com.jiuqi.util.patterns.PatternException;
import java.util.Map;

class VariablePattern implements IPattern {
  private String name;
  
  private int length;
  
  public void parse(String expression) throws PatternException {
    clear();
    if (expression == null)
      return; 
    int p = expression.lastIndexOf(':');
    if (p == -1) {
      this.name = expression;
      this.length = 0;
    } else {
      this.name = expression.substring(0, p);
      String valStr = expression.substring(p + 1);
      if (StringUtils.isEmpty(valStr)) {
        this.length = 0;
      } else {
        try {
          this.length = Integer.parseInt(valStr);
        } catch (NumberFormatException e) {
          throw new PatternException(e);
        } 
      } 
    } 
  }
  
  public String toString() {
    StringBuffer buffer = new StringBuffer("${");
    if (this.length == 0) {
      buffer.append(this.name);
    } else {
      buffer.append(this.name).append(':').append(this.length);
    } 
    buffer.append('}');
    return buffer.toString();
  }
  
  public void add(IPattern pattern) {}
  
  public void add(int index, IPattern pattern) {}
  
  public void clear() {
    this.name = null;
    this.length = 0;
  }
  
  public IPattern get(int index) {
    return null;
  }
  
  public String getExpression() {
    return this.name;
  }
  
  public int getLength() {
    return this.length;
  }
  
  public int getType() {
    return 1;
  }
  
  public int indexOf(IPattern pattern) {
    return -1;
  }
  
  public void remove(int index) {}
  
  public void setExpression(String value) {
    try {
      parse(value);
    } catch (PatternException patternException) {
      clear();
    } 
  }
  
  public void setLength(int value) {
    this.length = value;
  }
  
  public int size() {
    return 0;
  }
  
  public int match(String s, int start, Map values) {
    if (this.length == 0 || start + this.length > s.length())
      return -1; 
    return start + this.length;
  }
  
  public String replace(ITranslator translator) {
    String[] ret = translator.translate(this.name, this.length);
    if (ret == null)
      return toString(); 
    return (ret.length == 0) ? "" : ret[0];
  }
}
